<!DOCTYPE HTML>
<html lang="en">
<head>
<!-- Generated by javadoc (21) -->
<title>DefaultParser (Apache Commons CLI 1.6.0 API)</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="description" content="declaration: package: org.apache.commons.cli, class: DefaultParser">
<meta name="generator" content="javadoc/ClassWriterImpl">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../script-dir/jquery-ui.min.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
<script type="text/javascript" src="../../../../script-dir/jquery-3.6.1.min.js"></script>
<script type="text/javascript" src="../../../../script-dir/jquery-ui.min.js"></script>
</head>
<body class="class-declaration-page">
<script type="text/javascript">var pathtoroot = "../../../../";
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<div class="flex-box">
<header role="banner" class="flex-header">
<nav role="navigation">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="top-nav" id="navbar-top"><button id="navbar-toggle-button" aria-controls="navbar-top" aria-expanded="false" aria-label="Toggle navigation links"><span class="nav-bar-toggle-icon">&nbsp;</span><span class="nav-bar-toggle-icon">&nbsp;</span><span class="nav-bar-toggle-icon">&nbsp;</span></button>
<div class="skip-nav"><a href="#skip-navbar-top" title="Skip navigation links">Skip navigation links</a></div>
<ul id="navbar-top-firstrow" class="nav-list" title="Navigation">
<li><a href="package-summary.html">Package</a></li>
<li class="nav-bar-cell1-rev">Class</li>
<li><a href="class-use/DefaultParser.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html#class">Help</a></li>
</ul>
<ul class="sub-nav-list-small">
<li>
<p>Summary:</p>
<ul>
<li><a href="#nested-class-summary">Nested</a></li>
<li><a href="#field-summary">Field</a></li>
<li><a href="#constructor-summary">Constr</a></li>
<li><a href="#method-summary">Method</a></li>
</ul>
</li>
<li>
<p>Detail:</p>
<ul>
<li><a href="#field-detail">Field</a></li>
<li><a href="#constructor-detail">Constr</a></li>
<li><a href="#method-detail">Method</a></li>
</ul>
</li>
</ul>
</div>
<div class="sub-nav">
<div id="navbar-sub-list">
<ul class="sub-nav-list">
<li>Summary:&nbsp;</li>
<li><a href="#nested-class-summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field-summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor-summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method-summary">Method</a></li>
</ul>
<ul class="sub-nav-list">
<li>Detail:&nbsp;</li>
<li><a href="#field-detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor-detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method-detail">Method</a></li>
</ul>
</div>
<div class="nav-list-search"><a href="../../../../search.html">SEARCH</a>
<input type="text" id="search-input" disabled placeholder="Search">
<input type="reset" id="reset-button" disabled value="reset">
</div>
</div>
<!-- ========= END OF TOP NAVBAR ========= -->
<span class="skip-nav" id="skip-navbar-top"></span></nav>
</header>
<div class="flex-content">
<main role="main">
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="sub-title"><span class="package-label-in-type">Package</span>&nbsp;<a href="package-summary.html">org.apache.commons.cli</a></div>
<h1 title="Class DefaultParser" class="title">Class DefaultParser</h1>
</div>
<div class="inheritance" title="Inheritance Tree"><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html" title="class or interface in java.lang" class="external-link">java.lang.Object</a>
<div class="inheritance">org.apache.commons.cli.DefaultParser</div>
</div>
<section class="class-description" id="class-description">
<dl class="notes">
<dt>All Implemented Interfaces:</dt>
<dd><code><a href="CommandLineParser.html" title="interface in org.apache.commons.cli">CommandLineParser</a></code></dd>
</dl>
<hr>
<div class="type-signature"><span class="modifiers">public class </span><span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-30">DefaultParser</a></span>
<span class="extends-implements">extends <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html" title="class or interface in java.lang" class="external-link">Object</a>
implements <a href="CommandLineParser.html" title="interface in org.apache.commons.cli">CommandLineParser</a></span></div>
<div class="block">Default parser.</div>
<dl class="notes">
<dt>Since:</dt>
<dd>1.3</dd>
</dl>
</section>
<section class="summary">
<ul class="summary-list">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<li>
<section class="nested-class-summary" id="nested-class-summary">
<h2>Nested Class Summary</h2>
<div class="caption"><span>Nested Classes</span></div>
<div class="summary-table three-column-summary">
<div class="table-header col-first">Modifier and Type</div>
<div class="table-header col-second">Class</div>
<div class="table-header col-last">Description</div>
<div class="col-first even-row-color"><code>static final class&nbsp;</code></div>
<div class="col-second even-row-color"><code><a href="DefaultParser.Builder.html" class="type-name-link" title="class in org.apache.commons.cli">DefaultParser.Builder</a></code></div>
<div class="col-last even-row-color">
<div class="block">A nested builder class to create <code>DefaultParser</code> instances
 using descriptive methods.</div>
</div>
</div>
</section>
</li>
<!-- =========== FIELD SUMMARY =========== -->
<li>
<section class="field-summary" id="field-summary">
<h2>Field Summary</h2>
<div class="caption"><span>Fields</span></div>
<div class="summary-table three-column-summary">
<div class="table-header col-first">Modifier and Type</div>
<div class="table-header col-second">Field</div>
<div class="table-header col-last">Description</div>
<div class="col-first even-row-color"><code>protected <a href="CommandLine.html" title="class in org.apache.commons.cli">CommandLine</a></code></div>
<div class="col-second even-row-color"><code><a href="#cmd" class="member-name-link">cmd</a></code></div>
<div class="col-last even-row-color">
<div class="block">The command-line instance.</div>
</div>
<div class="col-first odd-row-color"><code>protected <a href="Option.html" title="class in org.apache.commons.cli">Option</a></code></div>
<div class="col-second odd-row-color"><code><a href="#currentOption" class="member-name-link">currentOption</a></code></div>
<div class="col-last odd-row-color">
<div class="block">The last option parsed.</div>
</div>
<div class="col-first even-row-color"><code>protected <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a></code></div>
<div class="col-second even-row-color"><code><a href="#currentToken" class="member-name-link">currentToken</a></code></div>
<div class="col-last even-row-color">
<div class="block">The token currently processed.</div>
</div>
<div class="col-first odd-row-color"><code>protected <a href="https://docs.oracle.com/javase/8/docs/api/java/util/List.html" title="class or interface in java.util" class="external-link">List</a></code></div>
<div class="col-second odd-row-color"><code><a href="#expectedOpts" class="member-name-link">expectedOpts</a></code></div>
<div class="col-last odd-row-color">
<div class="block">The required options and groups expected to be found when parsing the command line.</div>
</div>
<div class="col-first even-row-color"><code>protected <a href="Options.html" title="class in org.apache.commons.cli">Options</a></code></div>
<div class="col-second even-row-color"><code><a href="#options" class="member-name-link">options</a></code></div>
<div class="col-last even-row-color">
<div class="block">The current options.</div>
</div>
<div class="col-first odd-row-color"><code>protected boolean</code></div>
<div class="col-second odd-row-color"><code><a href="#skipParsing" class="member-name-link">skipParsing</a></code></div>
<div class="col-last odd-row-color">
<div class="block">Flag indicating if tokens should no longer be analyzed and simply added as arguments of the command line.</div>
</div>
<div class="col-first even-row-color"><code>protected boolean</code></div>
<div class="col-second even-row-color"><code><a href="#stopAtNonOption" class="member-name-link">stopAtNonOption</a></code></div>
<div class="col-last even-row-color">
<div class="block">Flag indicating how unrecognized tokens are handled.</div>
</div>
</div>
</section>
</li>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<li>
<section class="constructor-summary" id="constructor-summary">
<h2>Constructor Summary</h2>
<div class="caption"><span>Constructors</span></div>
<div class="summary-table two-column-summary">
<div class="table-header col-first">Constructor</div>
<div class="table-header col-last">Description</div>
<div class="col-constructor-name even-row-color"><code><a href="#%3Cinit%3E()" class="member-name-link">DefaultParser</a>()</code></div>
<div class="col-last even-row-color">
<div class="block">Creates a new DefaultParser instance with partial matching enabled.</div>
</div>
<div class="col-constructor-name odd-row-color"><code><a href="#%3Cinit%3E(boolean)" class="member-name-link">DefaultParser</a><wbr>(boolean&nbsp;allowPartialMatching)</code></div>
<div class="col-last odd-row-color">
<div class="block">Create a new DefaultParser instance with the specified partial matching policy.</div>
</div>
</div>
</section>
</li>
<!-- ========== METHOD SUMMARY =========== -->
<li>
<section class="method-summary" id="method-summary">
<h2>Method Summary</h2>
<div id="method-summary-table">
<div class="table-tabs" role="tablist" aria-orientation="horizontal"><button id="method-summary-table-tab0" role="tab" aria-selected="true" aria-controls="method-summary-table.tabpanel" tabindex="0" onkeydown="switchTab(event)" onclick="show('method-summary-table', 'method-summary-table', 3)" class="active-table-tab">All Methods</button><button id="method-summary-table-tab1" role="tab" aria-selected="false" aria-controls="method-summary-table.tabpanel" tabindex="-1" onkeydown="switchTab(event)" onclick="show('method-summary-table', 'method-summary-table-tab1', 3)" class="table-tab">Static Methods</button><button id="method-summary-table-tab2" role="tab" aria-selected="false" aria-controls="method-summary-table.tabpanel" tabindex="-1" onkeydown="switchTab(event)" onclick="show('method-summary-table', 'method-summary-table-tab2', 3)" class="table-tab">Instance Methods</button><button id="method-summary-table-tab4" role="tab" aria-selected="false" aria-controls="method-summary-table.tabpanel" tabindex="-1" onkeydown="switchTab(event)" onclick="show('method-summary-table', 'method-summary-table-tab4', 3)" class="table-tab">Concrete Methods</button></div>
<div id="method-summary-table.tabpanel" role="tabpanel">
<div class="summary-table three-column-summary" aria-labelledby="method-summary-table-tab0">
<div class="table-header col-first">Modifier and Type</div>
<div class="table-header col-second">Method</div>
<div class="table-header col-last">Description</div>
<div class="col-first even-row-color method-summary-table method-summary-table-tab1 method-summary-table-tab4"><code>static <a href="DefaultParser.Builder.html" title="class in org.apache.commons.cli">DefaultParser.Builder</a></code></div>
<div class="col-second even-row-color method-summary-table method-summary-table-tab1 method-summary-table-tab4"><code><a href="#builder()" class="member-name-link">builder</a>()</code></div>
<div class="col-last even-row-color method-summary-table method-summary-table-tab1 method-summary-table-tab4">
<div class="block">Creates a new <a href="DefaultParser.Builder.html" title="class in org.apache.commons.cli"><code>DefaultParser.Builder</code></a> to create an <a href="DefaultParser.html" title="class in org.apache.commons.cli"><code>DefaultParser</code></a> using descriptive
 methods.</div>
</div>
<div class="col-first odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code>protected void</code></div>
<div class="col-second odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#checkRequiredOptions()" class="member-name-link">checkRequiredOptions</a>()</code></div>
<div class="col-last odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Throws a <a href="MissingOptionException.html" title="class in org.apache.commons.cli"><code>MissingOptionException</code></a> if all of the required options are not present.</div>
</div>
<div class="col-first even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code>protected void</code></div>
<div class="col-second even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#handleConcatenatedOptions(java.lang.String)" class="member-name-link">handleConcatenatedOptions</a><wbr>(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>&nbsp;token)</code></div>
<div class="col-last even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Breaks <code>token</code> into its constituent parts using the following algorithm.</div>
</div>
<div class="col-first odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="CommandLine.html" title="class in org.apache.commons.cli">CommandLine</a></code></div>
<div class="col-second odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#parse(org.apache.commons.cli.Options,java.lang.String%5B%5D)" class="member-name-link">parse</a><wbr>(<a href="Options.html" title="class in org.apache.commons.cli">Options</a>&nbsp;options,
 <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>[]&nbsp;arguments)</code></div>
<div class="col-last odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Parses the arguments according to the specified options.</div>
</div>
<div class="col-first even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="CommandLine.html" title="class in org.apache.commons.cli">CommandLine</a></code></div>
<div class="col-second even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#parse(org.apache.commons.cli.Options,java.lang.String%5B%5D,boolean)" class="member-name-link">parse</a><wbr>(<a href="Options.html" title="class in org.apache.commons.cli">Options</a>&nbsp;options,
 <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>[]&nbsp;arguments,
 boolean&nbsp;stopAtNonOption)</code></div>
<div class="col-last even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Parses the arguments according to the specified options.</div>
</div>
<div class="col-first odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="CommandLine.html" title="class in org.apache.commons.cli">CommandLine</a></code></div>
<div class="col-second odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#parse(org.apache.commons.cli.Options,java.lang.String%5B%5D,java.util.Properties)" class="member-name-link">parse</a><wbr>(<a href="Options.html" title="class in org.apache.commons.cli">Options</a>&nbsp;options,
 <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>[]&nbsp;arguments,
 <a href="https://docs.oracle.com/javase/8/docs/api/java/util/Properties.html" title="class or interface in java.util" class="external-link">Properties</a>&nbsp;properties)</code></div>
<div class="col-last odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Parses the arguments according to the specified options and properties.</div>
</div>
<div class="col-first even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="CommandLine.html" title="class in org.apache.commons.cli">CommandLine</a></code></div>
<div class="col-second even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#parse(org.apache.commons.cli.Options,java.lang.String%5B%5D,java.util.Properties,boolean)" class="member-name-link">parse</a><wbr>(<a href="Options.html" title="class in org.apache.commons.cli">Options</a>&nbsp;options,
 <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>[]&nbsp;arguments,
 <a href="https://docs.oracle.com/javase/8/docs/api/java/util/Properties.html" title="class or interface in java.util" class="external-link">Properties</a>&nbsp;properties,
 boolean&nbsp;stopAtNonOption)</code></div>
<div class="col-last even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Parses the arguments according to the specified options and properties.</div>
</div>
</div>
</div>
</div>
<div class="inherited-list">
<h3 id="methods-inherited-from-class-java.lang.Object">Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html" title="class or interface in java.lang" class="external-link">Object</a></h3>
<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#clone--" title="class or interface in java.lang" class="external-link">clone</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#equals-java.lang.Object-" title="class or interface in java.lang" class="external-link">equals</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#finalize--" title="class or interface in java.lang" class="external-link">finalize</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#getClass--" title="class or interface in java.lang" class="external-link">getClass</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#hashCode--" title="class or interface in java.lang" class="external-link">hashCode</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#notify--" title="class or interface in java.lang" class="external-link">notify</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#notifyAll--" title="class or interface in java.lang" class="external-link">notifyAll</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#toString--" title="class or interface in java.lang" class="external-link">toString</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait--" title="class or interface in java.lang" class="external-link">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-" title="class or interface in java.lang" class="external-link">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-int-" title="class or interface in java.lang" class="external-link">wait</a></code></div>
</section>
</li>
</ul>
</section>
<section class="details">
<ul class="details-list">
<!-- ============ FIELD DETAIL =========== -->
<li>
<section class="field-details" id="field-detail">
<h2>Field Details</h2>
<ul class="member-list">
<li>
<section class="detail" id="cmd">
<h3>cmd</h3>
<div class="member-signature"><span class="modifiers">protected</span>&nbsp;<span class="return-type"><a href="CommandLine.html" title="class in org.apache.commons.cli">CommandLine</a></span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-133">cmd</a></span></div>
<div class="block">The command-line instance.</div>
</section>
</li>
<li>
<section class="detail" id="options">
<h3>options</h3>
<div class="member-signature"><span class="modifiers">protected</span>&nbsp;<span class="return-type"><a href="Options.html" title="class in org.apache.commons.cli">Options</a></span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-136">options</a></span></div>
<div class="block">The current options.</div>
</section>
</li>
<li>
<section class="detail" id="stopAtNonOption">
<h3>stopAtNonOption</h3>
<div class="member-signature"><span class="modifiers">protected</span>&nbsp;<span class="return-type">boolean</span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-142">stopAtNonOption</a></span></div>
<div class="block">Flag indicating how unrecognized tokens are handled. <code>true</code> to stop the parsing and add the remaining
 tokens to the args list. <code>false</code> to throw an exception.</div>
</section>
</li>
<li>
<section class="detail" id="currentToken">
<h3>currentToken</h3>
<div class="member-signature"><span class="modifiers">protected</span>&nbsp;<span class="return-type"><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a></span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-145">currentToken</a></span></div>
<div class="block">The token currently processed.</div>
</section>
</li>
<li>
<section class="detail" id="currentOption">
<h3>currentOption</h3>
<div class="member-signature"><span class="modifiers">protected</span>&nbsp;<span class="return-type"><a href="Option.html" title="class in org.apache.commons.cli">Option</a></span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-148">currentOption</a></span></div>
<div class="block">The last option parsed.</div>
</section>
</li>
<li>
<section class="detail" id="skipParsing">
<h3>skipParsing</h3>
<div class="member-signature"><span class="modifiers">protected</span>&nbsp;<span class="return-type">boolean</span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-151">skipParsing</a></span></div>
<div class="block">Flag indicating if tokens should no longer be analyzed and simply added as arguments of the command line.</div>
</section>
</li>
<li>
<section class="detail" id="expectedOpts">
<h3>expectedOpts</h3>
<div class="member-signature"><span class="modifiers">protected</span>&nbsp;<span class="return-type"><a href="https://docs.oracle.com/javase/8/docs/api/java/util/List.html" title="class or interface in java.util" class="external-link">List</a></span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-154">expectedOpts</a></span></div>
<div class="block">The required options and groups expected to be found when parsing the command line.</div>
</section>
</li>
</ul>
</section>
</li>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<li>
<section class="constructor-details" id="constructor-detail">
<h2>Constructor Details</h2>
<ul class="member-list">
<li>
<section class="detail" id="&lt;init&gt;()">
<h3>DefaultParser</h3>
<div class="member-signature"><span class="modifiers">public</span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-182">DefaultParser</a></span>()</div>
<div class="block">Creates a new DefaultParser instance with partial matching enabled.

 By "partial matching" we mean that given the following code:

 <pre>
 {
     &#64;code
     final Options options = new Options();
     options.addOption(new Option("d", "debug", false, "Turn on debug."));
     options.addOption(new Option("e", "extract", false, "Turn on extract."));
     options.addOption(new Option("o", "option", true, "Turn on option with argument."));
 }
 </pre>

 with "partial matching" turned on, <code>-de</code> only matches the <code>"debug"</code> option. However, with
 "partial matching" disabled, <code>-de</code> would enable both <code>debug</code> as well as <code>extract</code>
 options.</div>
</section>
</li>
<li>
<section class="detail" id="&lt;init&gt;(boolean)">
<h3>DefaultParser</h3>
<div class="member-signature"><span class="modifiers">public</span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-208">DefaultParser</a></span><wbr><span class="parameters">(boolean&nbsp;allowPartialMatching)</span></div>
<div class="block">Create a new DefaultParser instance with the specified partial matching policy.

 By "partial matching" we mean that given the following code:

 <pre>
 {
     &#64;code
     final Options options = new Options();
     options.addOption(new Option("d", "debug", false, "Turn on debug."));
     options.addOption(new Option("e", "extract", false, "Turn on extract."));
     options.addOption(new Option("o", "option", true, "Turn on option with argument."));
 }
 </pre>

 with "partial matching" turned on, <code>-de</code> only matches the <code>"debug"</code> option. However, with
 "partial matching" disabled, <code>-de</code> would enable both <code>debug</code> as well as <code>extract</code>
 options.</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>allowPartialMatching</code> - if partial matching of long options shall be enabled</dd>
</dl>
</section>
</li>
</ul>
</section>
</li>
<!-- ============ METHOD DETAIL ========== -->
<li>
<section class="method-details" id="method-detail">
<h2>Method Details</h2>
<ul class="member-list">
<li>
<section class="detail" id="builder()">
<h3>builder</h3>
<div class="member-signature"><span class="modifiers">public static</span>&nbsp;<span class="return-type"><a href="DefaultParser.Builder.html" title="class in org.apache.commons.cli">DefaultParser.Builder</a></span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-128">builder</a></span>()</div>
<div class="block">Creates a new <a href="DefaultParser.Builder.html" title="class in org.apache.commons.cli"><code>DefaultParser.Builder</code></a> to create an <a href="DefaultParser.html" title="class in org.apache.commons.cli"><code>DefaultParser</code></a> using descriptive
 methods.</div>
<dl class="notes">
<dt>Returns:</dt>
<dd>a new <a href="DefaultParser.Builder.html" title="class in org.apache.commons.cli"><code>DefaultParser.Builder</code></a> instance</dd>
<dt>Since:</dt>
<dd>1.5.0</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="checkRequiredOptions()">
<h3>checkRequiredOptions</h3>
<div class="member-signature"><span class="modifiers">protected</span>&nbsp;<span class="return-type">void</span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-240">checkRequiredOptions</a></span>()
                             throws <span class="exceptions"><a href="MissingOptionException.html" title="class in org.apache.commons.cli">MissingOptionException</a></span></div>
<div class="block">Throws a <a href="MissingOptionException.html" title="class in org.apache.commons.cli"><code>MissingOptionException</code></a> if all of the required options are not present.</div>
<dl class="notes">
<dt>Throws:</dt>
<dd><code><a href="MissingOptionException.html" title="class in org.apache.commons.cli">MissingOptionException</a></code> - if any of the required Options are not present.</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="handleConcatenatedOptions(java.lang.String)">
<h3>handleConcatenatedOptions</h3>
<div class="member-signature"><span class="modifiers">protected</span>&nbsp;<span class="return-type">void</span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-307">handleConcatenatedOptions</a></span><wbr><span class="parameters">(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>&nbsp;token)</span>
                                  throws <span class="exceptions"><a href="ParseException.html" title="class in org.apache.commons.cli">ParseException</a></span></div>
<div class="block">Breaks <code>token</code> into its constituent parts using the following algorithm.

 <ul>
 <li>ignore the first character ("<b>-</b>")</li>
 <li>for each remaining character check if an <a href="Option.html" title="class in org.apache.commons.cli"><code>Option</code></a> exists with that id.</li>
 <li>if an <a href="Option.html" title="class in org.apache.commons.cli"><code>Option</code></a> does exist then add that character prepended with "<b>-</b>" to the list of processed
 tokens.</li>
 <li>if the <a href="Option.html" title="class in org.apache.commons.cli"><code>Option</code></a> can have an argument value and there are remaining characters in the token then add the
 remaining characters as a token to the list of processed tokens.</li>
 <li>if an <a href="Option.html" title="class in org.apache.commons.cli"><code>Option</code></a> does <b>NOT</b> exist <b>AND</b> <code>stopAtNonOption</code> <b>IS</b> set then add the
 special token "<b>--</b>" followed by the remaining characters and also the remaining tokens directly to the
 processed tokens list.</li>
 <li>if an <a href="Option.html" title="class in org.apache.commons.cli"><code>Option</code></a> does <b>NOT</b> exist <b>AND</b> <code>stopAtNonOption</code> <b>IS NOT</b> set then add
 that character prepended with "<b>-</b>".</li>
 </ul></div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>token</code> - The current token to be <b>burst</b> at the first non-Option encountered.</dd>
<dt>Throws:</dt>
<dd><code><a href="ParseException.html" title="class in org.apache.commons.cli">ParseException</a></code> - if there are any problems encountered while parsing the command line token.</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="parse(org.apache.commons.cli.Options,java.lang.String[])">
<h3>parse</h3>
<div class="member-signature"><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="CommandLine.html" title="class in org.apache.commons.cli">CommandLine</a></span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-658">parse</a></span><wbr><span class="parameters">(<a href="Options.html" title="class in org.apache.commons.cli">Options</a>&nbsp;options,
 <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>[]&nbsp;arguments)</span>
                  throws <span class="exceptions"><a href="ParseException.html" title="class in org.apache.commons.cli">ParseException</a></span></div>
<div class="block"><span class="description-from-type-label">Description copied from interface:&nbsp;<code><a href="CommandLineParser.html#parse(org.apache.commons.cli.Options,java.lang.String%5B%5D)">CommandLineParser</a></code></span></div>
<div class="block">Parses the arguments according to the specified options.</div>
<dl class="notes">
<dt>Specified by:</dt>
<dd><code><a href="CommandLineParser.html#parse(org.apache.commons.cli.Options,java.lang.String%5B%5D)">parse</a></code>&nbsp;in interface&nbsp;<code><a href="CommandLineParser.html" title="interface in org.apache.commons.cli">CommandLineParser</a></code></dd>
<dt>Parameters:</dt>
<dd><code>options</code> - the specified Options</dd>
<dd><code>arguments</code> - the command line arguments</dd>
<dt>Returns:</dt>
<dd>the list of atomic option and value tokens</dd>
<dt>Throws:</dt>
<dd><code><a href="ParseException.html" title="class in org.apache.commons.cli">ParseException</a></code> - if there are any problems encountered while parsing the command line tokens.</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="parse(org.apache.commons.cli.Options,java.lang.String[],boolean)">
<h3>parse</h3>
<div class="member-signature"><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="CommandLine.html" title="class in org.apache.commons.cli">CommandLine</a></span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-663">parse</a></span><wbr><span class="parameters">(<a href="Options.html" title="class in org.apache.commons.cli">Options</a>&nbsp;options,
 <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>[]&nbsp;arguments,
 boolean&nbsp;stopAtNonOption)</span>
                  throws <span class="exceptions"><a href="ParseException.html" title="class in org.apache.commons.cli">ParseException</a></span></div>
<div class="block"><span class="description-from-type-label">Description copied from interface:&nbsp;<code><a href="CommandLineParser.html#parse(org.apache.commons.cli.Options,java.lang.String%5B%5D,boolean)">CommandLineParser</a></code></span></div>
<div class="block">Parses the arguments according to the specified options.</div>
<dl class="notes">
<dt>Specified by:</dt>
<dd><code><a href="CommandLineParser.html#parse(org.apache.commons.cli.Options,java.lang.String%5B%5D,boolean)">parse</a></code>&nbsp;in interface&nbsp;<code><a href="CommandLineParser.html" title="interface in org.apache.commons.cli">CommandLineParser</a></code></dd>
<dt>Parameters:</dt>
<dd><code>options</code> - the specified Options</dd>
<dd><code>arguments</code> - the command line arguments</dd>
<dd><code>stopAtNonOption</code> - if <code>true</code> an unrecognized argument stops the parsing and the remaining arguments
        are added to the <a href="CommandLine.html" title="class in org.apache.commons.cli"><code>CommandLine</code></a>s args list. If <code>false</code> an unrecognized argument triggers a
        ParseException.</dd>
<dt>Returns:</dt>
<dd>the list of atomic option and value tokens</dd>
<dt>Throws:</dt>
<dd><code><a href="ParseException.html" title="class in org.apache.commons.cli">ParseException</a></code> - if there are any problems encountered while parsing the command line tokens.</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="parse(org.apache.commons.cli.Options,java.lang.String[],java.util.Properties)">
<h3>parse</h3>
<div class="member-signature"><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="CommandLine.html" title="class in org.apache.commons.cli">CommandLine</a></span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-678">parse</a></span><wbr><span class="parameters">(<a href="Options.html" title="class in org.apache.commons.cli">Options</a>&nbsp;options,
 <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>[]&nbsp;arguments,
 <a href="https://docs.oracle.com/javase/8/docs/api/java/util/Properties.html" title="class or interface in java.util" class="external-link">Properties</a>&nbsp;properties)</span>
                  throws <span class="exceptions"><a href="ParseException.html" title="class in org.apache.commons.cli">ParseException</a></span></div>
<div class="block">Parses the arguments according to the specified options and properties.</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>options</code> - the specified Options</dd>
<dd><code>arguments</code> - the command line arguments</dd>
<dd><code>properties</code> - command line option name-value pairs</dd>
<dt>Returns:</dt>
<dd>the list of atomic option and value tokens</dd>
<dt>Throws:</dt>
<dd><code><a href="ParseException.html" title="class in org.apache.commons.cli">ParseException</a></code> - if there are any problems encountered while parsing the command line tokens.</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="parse(org.apache.commons.cli.Options,java.lang.String[],java.util.Properties,boolean)">
<h3>parse</h3>
<div class="member-signature"><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="CommandLine.html" title="class in org.apache.commons.cli">CommandLine</a></span>&nbsp;<span class="element-name"><a href="../../../../src-html/org/apache/commons/cli/DefaultParser.html#line-695">parse</a></span><wbr><span class="parameters">(<a href="Options.html" title="class in org.apache.commons.cli">Options</a>&nbsp;options,
 <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>[]&nbsp;arguments,
 <a href="https://docs.oracle.com/javase/8/docs/api/java/util/Properties.html" title="class or interface in java.util" class="external-link">Properties</a>&nbsp;properties,
 boolean&nbsp;stopAtNonOption)</span>
                  throws <span class="exceptions"><a href="ParseException.html" title="class in org.apache.commons.cli">ParseException</a></span></div>
<div class="block">Parses the arguments according to the specified options and properties.</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>options</code> - the specified Options</dd>
<dd><code>arguments</code> - the command line arguments</dd>
<dd><code>properties</code> - command line option name-value pairs</dd>
<dd><code>stopAtNonOption</code> - if <code>true</code> an unrecognized argument stops the parsing and the remaining arguments
        are added to the <a href="CommandLine.html" title="class in org.apache.commons.cli"><code>CommandLine</code></a>s args list. If <code>false</code> an unrecognized argument triggers a
        ParseException.</dd>
<dt>Returns:</dt>
<dd>the list of atomic option and value tokens</dd>
<dt>Throws:</dt>
<dd><code><a href="ParseException.html" title="class in org.apache.commons.cli">ParseException</a></code> - if there are any problems encountered while parsing the command line tokens.</dd>
</dl>
</section>
</li>
</ul>
</section>
</li>
</ul>
</section>
<!-- ========= END OF CLASS DATA ========= -->
</main>
<footer role="contentinfo">
<hr>
<p class="legal-copy"><small>Copyright &#169; 2002&#x2013;2023 <a href="https://www.apache.org/">The Apache Software Foundation</a>. All rights reserved.</small></p>
</footer>
</div>
</div>
</body>
</html>
